TanStack

Solid Example: Queue

import { createSignal } from 'solid-js'
import { render } from 'solid-js/web'
import { queue } from '@tanstack/solid-pacer/queuer'
import { pacerDevtoolsPlugin } from '@tanstack/solid-pacer-devtools'
import { TanStackDevtools } from '@tanstack/solid-devtools'

function App1() {
  const [queueItems, setQueueItems] = createSignal<Array<number>>([])
  const [processedCount, setProcessedCount] = createSignal(0)

  function processQueueItem(item: number) {
    console.log(item)
  }

  // Create the simplified queuer function
  const queueItem = queue<number>(processQueueItem, {
    maxSize: 25,
    wait: 1000,
    onItemsChange: (queue) => {
      setQueueItems(queue.peekAllItems())
      setProcessedCount(queue.store.state.executionCount)
    },
  })

  return (
    <div>
      <h1>TanStack Pacer queue Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Queue Size:</td>
            <td>{queueItems().length}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{processedCount()}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{queueItems().join(', ')}</td>
          </tr>
        </tbody>
      </table>
      <button
        onClick={() => {
          const nextNumber = queueItems().length
            ? queueItems()[queueItems().length - 1] + 1
            : 1
          queueItem(nextNumber)
        }}
        disabled={queueItems().length >= 25}
      >
        Add Number
      </button>
    </div>
  )
}

function App2() {
  const [queueItems, setQueueItems] = createSignal<Array<string>>([])
  const [processedCount, setProcessedCount] = createSignal(0)
  const [inputText, setInputText] = createSignal('')
  const [queuedText, setQueuedText] = createSignal('')

  function processQueueItem(item: string) {
    setQueuedText(item)
  }

  // Create the simplified queuer function
  const queueTextChange = queue<string>(processQueueItem, {
    maxSize: 100,
    wait: 500,
    onItemsChange: (queue) => {
      setQueueItems(queue.peekAllItems())
      setProcessedCount(queue.store.state.executionCount)
    },
  })

  function handleInputChange(e: Event) {
    setInputText((e.target as HTMLInputElement).value)
    queueTextChange((e.target as HTMLInputElement).value)
  }

  return (
    <div>
      <h1>TanStack Pacer queue Example 2</h1>
      <div>
        <input
          autofocus
          type="search"
          value={inputText()}
          onInput={handleInputChange}
          placeholder="Type to add to queue..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Queued Text:</td>
            <td>{queuedText()}</td>
          </tr>
          <tr>
            <td>Queue Size:</td>
            <td>{queueItems().length}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{processedCount()}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{queueItems().join(', ')}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

function App3() {
  const [queueItems, setQueueItems] = createSignal<Array<number>>([])
  const [processedCount, setProcessedCount] = createSignal(0)
  const [currentValue, setCurrentValue] = createSignal(50)
  const [queuedValue, setQueuedValue] = createSignal(50)

  function processQueueItem(item: number) {
    setQueuedValue(item)
  }

  // Create the simplified queuer function
  const queueValue = queue<number>(processQueueItem, {
    maxSize: 100,
    wait: 100,
    onItemsChange: (queue) => {
      setQueueItems(queue.peekAllItems())
      setProcessedCount(queue.store.state.executionCount)
    },
  })

  function handleRangeChange(e: Event) {
    const target = e.target as HTMLInputElement
    const newValue = parseInt(target.value, 10)
    setCurrentValue(newValue)
    queueValue(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer queue Example 3</h1>
      <div style={{ 'margin-bottom': '20px' }}>
        <label>
          Current Range:
          <input
            type="range"
            min="0"
            max="100"
            value={currentValue()}
            onInput={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{currentValue()}</span>
        </label>
      </div>
      <div style={{ 'margin-bottom': '20px' }}>
        <label>
          Queued Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={queuedValue()}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{queuedValue()}</span>
        </label>
      </div>
      <table>
        <tbody>
          <tr>
            <td>Queue Size:</td>
            <td>{queueItems().length}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{processedCount()}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{queueItems().join(', ')}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

render(
  () => (
    <div>
      <App1 />
      <hr />
      <App2 />
      <hr />
      <App3 />
      <TanStackDevtools
        eventBusConfig={{
          debug: false,
        }}
        plugins={[pacerDevtoolsPlugin()]}
      />
    </div>
  ),
  document.getElementById('root')!,
)

TanStack

Svelte Example: Queue

<script lang="ts">
  import { TanStackDevtools } from '@tanstack/svelte-devtools'
  import { pacerDevtoolsPlugin } from '@tanstack/svelte-pacer-devtools'
  import { queue } from '@tanstack/svelte-pacer/queuer'

  let counterQueueItems = $state<Array<number>>([])

  let counterProcessedCount = $state(0)

  function counterProcessQueueItem(item: number) {
    console.log('Processing item:', item)
  }

  // Create the simplified queuer function
  const queueItem = queue<number>(counterProcessQueueItem, {
    key: 'Add Number Queue',
    maxSize: 25,
    wait: 1000,
    onItemsChange: (queue) => {
      counterQueueItems = queue.peekAllItems()
    },
    onExecute: (_item, queue) => {
      counterProcessedCount = queue.store.state.executionCount
    },
  })

  let rangeQueueItems = $state<Array<number>>([])

  let rangeProcessedCount = $state(0)

  let currentValue = $state(50)

  let queuedValue = $state(50)

  function rangeProcessQueueItem(item: number) {
    queuedValue = item
  }

  // Create the simplified queuer function
  const queueValue = queue<number>(rangeProcessQueueItem, {
    key: 'Range Change Queue',
    maxSize: 100,
    wait: 100,
    onItemsChange: (queue) => {
      rangeQueueItems = queue.peekAllItems()
    },
    onExecute: (_item, queue) => {
      rangeProcessedCount = queue.store.state.executionCount
    },
  })

  function handleRangeChange(e: Event) {
    const newValue = parseInt((e.target as HTMLInputElement).value, 10)
    currentValue = newValue
    queueValue(newValue)
  }

  let searchQueueItems = $state<Array<string>>([])

  let searchProcessedCount = $state(0)

  let inputText = $state('')

  let queuedText = $state('')

  function searchProcessQueueItem(item: string) {
    queuedText = item
  }

  // Create the simplified queuer function
  const queueTextChange = queue<string>(searchProcessQueueItem, {
    key: 'Text Change Queue',
    maxSize: 100,
    wait: 500,
    onItemsChange: (queue) => {
      searchQueueItems = queue.peekAllItems()
    },
    onExecute: (_item, queue) => {
      searchProcessedCount = queue.store.state.executionCount
    },
  })

  function handleInputChange(e: Event) {
    inputText = (e.target as HTMLInputElement).value
    queueTextChange((e.target as HTMLInputElement).value)
  }
</script>

<div>
  <div>
    <h1>TanStack Pacer queue Example 1</h1>
    <table>
      <tbody
        ><tr><td>Queue Size:</td><td>{counterQueueItems.length}</td></tr><tr
          ><td>Items Processed:</td><td>{counterProcessedCount}</td></tr
        ><tr><td>Queue Items:</td><td>{counterQueueItems.join(', ')}</td></tr
        ></tbody
      >
    </table>
    <button
      onclick={() => {
        const nextNumber = counterQueueItems.length
          ? counterQueueItems[counterQueueItems.length - 1]! + 1
          : 1
        queueItem(nextNumber)
      }}
      disabled={counterQueueItems.length >= 25}
    >
      Add Number
    </button>
  </div>
  <hr />
  <div>
    <h1>TanStack Pacer queue Example 2</h1>
    <div>
      <input
        type="search"
        value={inputText}
        oninput={handleInputChange}
        placeholder="Type to add to queue..."
        style="width: 100%"
      />
    </div>
    <table>
      <tbody
        ><tr><td>Queued Text:</td><td>{queuedText}</td></tr><tr
          ><td>Queue Size:</td><td>{searchQueueItems.length}</td></tr
        ><tr><td>Items Processed:</td><td>{searchProcessedCount}</td></tr><tr
          ><td>Queue Items:</td><td>{searchQueueItems.join(', ')}</td></tr
        ></tbody
      >
    </table>
  </div>
  <hr />
  <div>
    <h1>TanStack Pacer queue Example 3</h1>
    <div style="margin-bottom: 20px">
      <label
        >Current Range:<input
          type="range"
          min="0"
          max="100"
          value={currentValue}
          oninput={handleRangeChange}
          style="width: 100%"
        /><span>{currentValue}</span></label
      >
    </div>
    <div style="margin-bottom: 20px">
      <label
        >Queued Range (Readonly):<input
          type="range"
          min="0"
          max="100"
          value={queuedValue}
          disabled
          style="width: 100%"
        /><span>{queuedValue}</span></label
      >
    </div>
    <table>
      <tbody
        ><tr><td>Queue Size:</td><td>{rangeQueueItems.length}</td></tr><tr
          ><td>Items Processed:</td><td>{rangeProcessedCount}</td></tr
        ><tr><td>Queue Items:</td><td>{rangeQueueItems.join(', ')}</td></tr
        ></tbody
      >
    </table>
  </div>
</div>
{#if import.meta.env.DEV}<TanStackDevtools
    plugins={[pacerDevtoolsPlugin()]}
  />{/if}

Docs
Cloudflare
Railway
CodeRabbit
SerpAPI
Netlify
Clerk
AG Grid
WorkOS
OpenRouter
Prisma
Unkey
Sentry
Electric
Cloudflare
Railway
CodeRabbit
SerpAPI
Netlify
Clerk
AG Grid
WorkOS
OpenRouter
Prisma
Unkey
Sentry
Electric
Debouncer API Reference
Throttler API Reference
Rate Limiter API Reference
Queue API Reference
Batcher API Reference

React Example: Queue

import { useCallback, useState } from 'react'
import ReactDOM from 'react-dom/client'
import { pacerDevtoolsPlugin } from '@tanstack/react-pacer-devtools'
import { TanStackDevtools } from '@tanstack/react-devtools'
import { queue } from '@tanstack/react-pacer/queuer'

function App1() {
  const [queueItems, setQueueItems] = useState<Array<number>>([])
  const [processedCount, setProcessedCount] = useState(0)

  function processQueueItem(item: number) {
    console.log('Processing item:', item)
  }

  // Create the simplified queuer function
  const queueItem = useCallback(
    queue<number>(processQueueItem, {
      key: 'Add Number Queue',
      maxSize: 25,
      wait: 1000,
      onItemsChange: (queue) => {
        setQueueItems(queue.peekAllItems())
        setProcessedCount(queue.store.state.executionCount)
      },
    }),
    [], // must be memoized to avoid re-creating the queue on every render (consider using useQueuer instead in react)
  )

  return (
    <div>
      <h1>TanStack Pacer queue Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Queue Size:</td>
            <td>{queueItems.length}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{processedCount}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{queueItems.join(', ')}</td>
          </tr>
        </tbody>
      </table>
      <button
        onClick={() => {
          const nextNumber = queueItems.length
            ? queueItems[queueItems.length - 1] + 1
            : 1
          queueItem(nextNumber)
        }}
        disabled={queueItems.length >= 25}
      >
        Add Number
      </button>
    </div>
  )
}

function App2() {
  const [queueItems, setQueueItems] = useState<Array<string>>([])
  const [processedCount, setProcessedCount] = useState(0)
  const [inputText, setInputText] = useState('')
  const [queuedText, setQueuedText] = useState('')

  function processQueueItem(item: string) {
    setQueuedText(item)
  }

  // Create the simplified queuer function
  const queueTextChange = useCallback(
    queue<string>(processQueueItem, {
      key: 'Text Change Queue',
      maxSize: 100,
      wait: 500,
      onItemsChange: (queue) => {
        setQueueItems(queue.peekAllItems())
        setProcessedCount(queue.store.state.executionCount)
      },
    }),
    [],
  )

  function handleInputChange(e: React.ChangeEvent<HTMLInputElement>) {
    setInputText(e.target.value)
    queueTextChange(e.target.value)
  }

  return (
    <div>
      <h1>TanStack Pacer queue Example 2</h1>
      <div>
        <input
          autoFocus
          type="search"
          value={inputText}
          onChange={handleInputChange}
          placeholder="Type to add to queue..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Queued Text:</td>
            <td>{queuedText}</td>
          </tr>
          <tr>
            <td>Queue Size:</td>
            <td>{queueItems.length}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{processedCount}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{queueItems.join(', ')}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

function App3() {
  const [queueItems, setQueueItems] = useState<Array<number>>([])
  const [processedCount, setProcessedCount] = useState(0)
  const [currentValue, setCurrentValue] = useState(50)
  const [queuedValue, setQueuedValue] = useState(50)

  function processQueueItem(item: number) {
    setQueuedValue(item)
  }

  // Create the simplified queuer function
  const queueValue = useCallback(
    queue<number>(processQueueItem, {
      key: 'Range Change Queue',
      maxSize: 100,
      wait: 100,
      onItemsChange: (queue) => {
        setQueueItems(queue.peekAllItems())
        setProcessedCount(queue.store.state.executionCount)
      },
    }),
    [],
  )

  function handleRangeChange(e: React.ChangeEvent<HTMLInputElement>) {
    const newValue = parseInt(e.target.value, 10)
    setCurrentValue(newValue)
    queueValue(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer queue Example 3</h1>
      <div style={{ marginBottom: '20px' }}>
        <label>
          Current Range:
          <input
            type="range"
            min="0"
            max="100"
            value={currentValue}
            onChange={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{currentValue}</span>
        </label>
      </div>
      <div style={{ marginBottom: '20px' }}>
        <label>
          Queued Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={queuedValue}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{queuedValue}</span>
        </label>
      </div>
      <table>
        <tbody>
          <tr>
            <td>Queue Size:</td>
            <td>{queueItems.length}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{processedCount}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{queueItems.join(', ')}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(
  <div>
    <App1 />
    <hr />
    <App2 />
    <hr />
    <App3 />
    <TanStackDevtools
      eventBusConfig={{
        debug: false,
      }}
      plugins={[pacerDevtoolsPlugin()]}
    />
  </div>,
)
import { useCallback, useState } from 'react'
import ReactDOM from 'react-dom/client'
import { pacerDevtoolsPlugin } from '@tanstack/react-pacer-devtools'
import { TanStackDevtools } from '@tanstack/react-devtools'
import { queue } from '@tanstack/react-pacer/queuer'

function App1() {
  const [queueItems, setQueueItems] = useState<Array<number>>([])
  const [processedCount, setProcessedCount] = useState(0)

  function processQueueItem(item: number) {
    console.log('Processing item:', item)
  }

  // Create the simplified queuer function
  const queueItem = useCallback(
    queue<number>(processQueueItem, {
      key: 'Add Number Queue',
      maxSize: 25,
      wait: 1000,
      onItemsChange: (queue) => {
        setQueueItems(queue.peekAllItems())
        setProcessedCount(queue.store.state.executionCount)
      },
    }),
    [], // must be memoized to avoid re-creating the queue on every render (consider using useQueuer instead in react)
  )

  return (
    <div>
      <h1>TanStack Pacer queue Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Queue Size:</td>
            <td>{queueItems.length}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{processedCount}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{queueItems.join(', ')}</td>
          </tr>
        </tbody>
      </table>
      <button
        onClick={() => {
          const nextNumber = queueItems.length
            ? queueItems[queueItems.length - 1] + 1
            : 1
          queueItem(nextNumber)
        }}
        disabled={queueItems.length >= 25}
      >
        Add Number
      </button>
    </div>
  )
}

function App2() {
  const [queueItems, setQueueItems] = useState<Array<string>>([])
  const [processedCount, setProcessedCount] = useState(0)
  const [inputText, setInputText] = useState('')
  const [queuedText, setQueuedText] = useState('')

  function processQueueItem(item: string) {
    setQueuedText(item)
  }

  // Create the simplified queuer function
  const queueTextChange = useCallback(
    queue<string>(processQueueItem, {
      key: 'Text Change Queue',
      maxSize: 100,
      wait: 500,
      onItemsChange: (queue) => {
        setQueueItems(queue.peekAllItems())
        setProcessedCount(queue.store.state.executionCount)
      },
    }),
    [],
  )

  function handleInputChange(e: React.ChangeEvent<HTMLInputElement>) {
    setInputText(e.target.value)
    queueTextChange(e.target.value)
  }

  return (
    <div>
      <h1>TanStack Pacer queue Example 2</h1>
      <div>
        <input
          autoFocus
          type="search"
          value={inputText}
          onChange={handleInputChange}
          placeholder="Type to add to queue..."
          style={{ width: '100%' }}
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Queued Text:</td>
            <td>{queuedText}</td>
          </tr>
          <tr>
            <td>Queue Size:</td>
            <td>{queueItems.length}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{processedCount}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{queueItems.join(', ')}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

function App3() {
  const [queueItems, setQueueItems] = useState<Array<number>>([])
  const [processedCount, setProcessedCount] = useState(0)
  const [currentValue, setCurrentValue] = useState(50)
  const [queuedValue, setQueuedValue] = useState(50)

  function processQueueItem(item: number) {
    setQueuedValue(item)
  }

  // Create the simplified queuer function
  const queueValue = useCallback(
    queue<number>(processQueueItem, {
      key: 'Range Change Queue',
      maxSize: 100,
      wait: 100,
      onItemsChange: (queue) => {
        setQueueItems(queue.peekAllItems())
        setProcessedCount(queue.store.state.executionCount)
      },
    }),
    [],
  )

  function handleRangeChange(e: React.ChangeEvent<HTMLInputElement>) {
    const newValue = parseInt(e.target.value, 10)
    setCurrentValue(newValue)
    queueValue(newValue)
  }

  return (
    <div>
      <h1>TanStack Pacer queue Example 3</h1>
      <div style={{ marginBottom: '20px' }}>
        <label>
          Current Range:
          <input
            type="range"
            min="0"
            max="100"
            value={currentValue}
            onChange={handleRangeChange}
            style={{ width: '100%' }}
          />
          <span>{currentValue}</span>
        </label>
      </div>
      <div style={{ marginBottom: '20px' }}>
        <label>
          Queued Range (Readonly):
          <input
            type="range"
            min="0"
            max="100"
            value={queuedValue}
            readOnly
            style={{ width: '100%' }}
          />
          <span>{queuedValue}</span>
        </label>
      </div>
      <table>
        <tbody>
          <tr>
            <td>Queue Size:</td>
            <td>{queueItems.length}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{processedCount}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{queueItems.join(', ')}</td>
          </tr>
        </tbody>
      </table>
    </div>
  )
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(
  <div>
    <App1 />
    <hr />
    <App2 />
    <hr />
    <App3 />
    <TanStackDevtools
      eventBusConfig={{
        debug: false,
      }}
      plugins={[pacerDevtoolsPlugin()]}
    />
  </div>,
)

TanStack
<script setup lang="ts">
import { TanStackDevtools } from '@tanstack/vue-devtools'
import { pacerDevtoolsPlugin } from '@tanstack/vue-pacer-devtools'
import { ref } from 'vue'
import { queue } from '@tanstack/vue-pacer/queuer'

const dev = import.meta.env.DEV
const plugins = [pacerDevtoolsPlugin()]

const counterQueueItems = ref<Array<number>>([])

const counterProcessedCount = ref(0)

function counterProcessQueueItem(item: number) {
  console.log('Processing item:', item)
}

// Create the simplified queuer function
const queueItem = queue<number>(counterProcessQueueItem, {
  key: 'Add Number Queue',
  maxSize: 25,
  wait: 1000,
  onItemsChange: (queue) => {
    counterQueueItems.value = queue.peekAllItems()
  },
  onExecute: (_item, queue) => {
    counterProcessedCount.value = queue.store.state.executionCount
  },
})

const searchQueueItems = ref<Array<string>>([])

const searchProcessedCount = ref(0)

const inputText = ref('')

const queuedText = ref('')

function searchProcessQueueItem(item: string) {
  queuedText.value = item
}

// Create the simplified queuer function
const queueTextChange = queue<string>(searchProcessQueueItem, {
  key: 'Text Change Queue',
  maxSize: 100,
  wait: 500,
  onItemsChange: (queue) => {
    searchQueueItems.value = queue.peekAllItems()
  },
  onExecute: (_item, queue) => {
    searchProcessedCount.value = queue.store.state.executionCount
  },
})

function handleInputChange(e: Event) {
  inputText.value = (e.target as HTMLInputElement).value
  queueTextChange((e.target as HTMLInputElement).value)
}

const rangeQueueItems = ref<Array<number>>([])

const rangeProcessedCount = ref(0)

const currentValue = ref(50)

const queuedValue = ref(50)

function rangeProcessQueueItem(item: number) {
  queuedValue.value = item
}

// Create the simplified queuer function
const queueValue = queue<number>(rangeProcessQueueItem, {
  key: 'Range Change Queue',
  maxSize: 100,
  wait: 100,
  onItemsChange: (queue) => {
    rangeQueueItems.value = queue.peekAllItems()
  },
  onExecute: (_item, queue) => {
    rangeProcessedCount.value = queue.store.state.executionCount
  },
})

function handleRangeChange(e: Event) {
  const newValue = parseInt((e.target as HTMLInputElement).value, 10)
  currentValue.value = newValue
  queueValue(newValue)
}
</script>

<template>
  <div>
    <div>
      <h1>TanStack Pacer queue Example 1</h1>
      <table>
        <tbody>
          <tr>
            <td>Queue Size:</td>
            <td>{{ counterQueueItems.length }}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{{ counterProcessedCount }}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{{ counterQueueItems.join(', ') }}</td>
          </tr>
        </tbody>
      </table>
      <button
        @click="
          () => {
            const nextNumber = counterQueueItems.length
              ? counterQueueItems[counterQueueItems.length - 1]! + 1
              : 1
            queueItem(nextNumber)
          }
        "
        :disabled="counterQueueItems.length >= 25"
      >
        Add Number
      </button>
    </div>
    <hr />
    <div>
      <h1>TanStack Pacer queue Example 2</h1>
      <div>
        <input
          type="search"
          :value="inputText"
          @input="handleInputChange"
          placeholder="Type to add to queue..."
          :style="{ width: '100%' }"
        />
      </div>
      <table>
        <tbody>
          <tr>
            <td>Queued Text:</td>
            <td>{{ queuedText }}</td>
          </tr>
          <tr>
            <td>Queue Size:</td>
            <td>{{ searchQueueItems.length }}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{{ searchProcessedCount }}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{{ searchQueueItems.join(', ') }}</td>
          </tr>
        </tbody>
      </table>
    </div>
    <hr />
    <div>
      <h1>TanStack Pacer queue Example 3</h1>
      <div :style="{ marginBottom: '20px' }">
        <label
          >Current Range:<input
            type="range"
            min="0"
            max="100"
            :value="currentValue"
            @input="handleRangeChange"
            :style="{ width: '100%' }"
          /><span>{{ currentValue }}</span></label
        >
      </div>
      <div :style="{ marginBottom: '20px' }">
        <label
          >Queued Range (Readonly):<input
            type="range"
            min="0"
            max="100"
            :value="queuedValue"
            disabled
            :style="{ width: '100%' }"
          /><span>{{ queuedValue }}</span></label
        >
      </div>
      <table>
        <tbody>
          <tr>
            <td>Queue Size:</td>
            <td>{{ rangeQueueItems.length }}</td>
          </tr>
          <tr>
            <td>Items Processed:</td>
            <td>{{ rangeProcessedCount }}</td>
          </tr>
          <tr>
            <td>Queue Items:</td>
            <td>{{ rangeQueueItems.join(', ') }}</td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
  <TanStackDevtools v-if="dev" :plugins="plugins" />
</template>